﻿using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Navigation;
using System.Threading.Tasks;
using System.Threading.Tasks.Dataflow;


namespace VSMDataflowPart3
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected async override void OnNavigatedTo(NavigationEventArgs e)
        {
            UiUpdateBlock<int> test = new UiUpdateBlock<int>(Message);
            var customBLock = CreateUpdateUiBlock<int, string>(EncapsulateMessage);

            for (int i = 0; i < 100; i++)
            {
                await Task.Delay(200);
                await test.SendAsync(i);
                await customBLock.SendAsync(i);
            }
        }

        private static IPropagatorBlock<TInput, TOutput> CreateUpdateUiBlock<TInput, TOutput>(TextBlock element)
        {
            var source = new BroadcastBlock<TOutput>(x => x);
            var target = new ActionBlock<TInput>(x => element.Text = x.ToString(),
                 new ExecutionDataflowBlockOptions() 
                { TaskScheduler = TaskScheduler.FromCurrentSynchronizationContext() });
            return DataflowBlock.Encapsulate(target, source);
        }
    }
}